open Xml;

void print_node(node n)
{
	void print_attr(*[string, string] p)
	{
		let [na, v] = p in
		print_string(" " + na + "=\"" + v + "\"");
	}
	
	switch n {
	case Element[name, children, attrs]:
		print_string("<" + name);
		List::iter(print_attr, attrs);
		print_string(">\n");
		List::iter(print_node, children);
		print_string("</" + name + ">\n");

	case Text[s]:
		print_string("'" + s + "'\n");
	}
}



section init
{
	doc d;

	try {
		d = parse_file("t1.xml", false);
		print_node(root_node(d));

		print_string(string_of_doc(d));
	} with {
	case ParseError[s]:
		print_string(s + "\n");
	}
}
